<?php
/*--------------------------------------------+
| RSS Parser version 1.0                      |
|---------------------------------------------|
| author: Scott Rutherford (surreal)  2005   |
| web: http://www.maiden-city.co.uk           |
| email: scott@maiden-city.co.uk              |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/
class rss_parser  {
	var $parser;
	var $news = array();
	var $xmldata = '';
	var $itemCount = -1;
	var $inItem = false;
	var $elName = '';
	var $title = '';
	var $description = '';
	var $linkx = '';

	function rss_parser() {
		$this->parser = xml_parser_create();
		
		xml_set_object($this->parser, $this);
		xml_set_element_handler($this->parser, "elementOpen", "elementClose");
		xml_set_character_data_handler($this->parser, "characterData");
	}
	
	function parse($file, $num=0) {
		if(empty($this->news)) {
			$this->getFile($file);
			xml_parse($this->parser, $this->xmldata);
		};
		
		return array_slice($this->news, 0, $num);
	}
	
	function getFile($address) {
		if(empty($address)) {
			print 'There is no rss file set.';
		} elseif (!($fp = fopen($address, "r"))) {
			die("could not open XML input");
		}
		
		while (!feof($fp)) {
			$this->xmldata .= fgets ($fp, 4026);
		}
	}
	
	function elementOpen($parser, $name, $attributes) {
		if($this->inItem) {
			$this->elName = $name;
		} elseif($name == 'ITEM') {
			$this->inItem = true;
			$this->itemCount ++;
		};
	}

	function characterData($parser, $data) {
		if($this->inItem) {
			switch ($this->elName) {
				case 'TITLE':
					$this->title .= $data;
					break;
				case 'DESCRIPTION':
					$this->description .= $data;
					break;
				case 'LINK':
					$this->linkx .= $data;
					break;
			}
		}
	}

   function elementClose($parser, $name) {
		if($name == 'ITEM') {
			$this->inItem = false;
		} else {
			switch ($this->elName) {
				case 'TITLE':
					$this->news[$this->itemCount]['title'] = trim($this->title);
					break;
				case 'DESCRIPTION':
					$this->news[$this->itemCount]['description'] = trim($this->description);
					break;
				case 'LINK':
					$this->news[$this->itemCount]['link'] = trim($this->linkx);
					break;
			}
			
			$this->title = '';
			$this->description = '';
			$this->linkx = '';
		}
	}

}

$rss_parser = new rss_parser;

?> 